#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    map<string,int> Zalihe;
    cin>>n;
    cin>>Zalihe["O"]>>Zalihe["A"]>>Zalihe["B"]>>Zalihe["AB"];
    vector<pair<string,int>> Pacijenti(n);
    int ans[n][4];
    for(int i=0; i<n; i++)
    {
        cin>>Pacijenti[i].first;
        cin>>Pacijenti[i].second;
        for(int j =0; j<4; j++)ans[i][j]=0;
    }

    for(int i = 0; i<n; i++)
    {
        if(Pacijenti[i].first=="O")
        {
            if(Zalihe["O"]<Pacijenti[i].second)
            {
                cout<<"nemoguce";
                return 0;
            }
            else
            {
                ans[i][0]=Pacijenti[i].second;
                Zalihe["O"]-=Pacijenti[i].second;
            }
        }
    }

    for(int i = 0; i<n; i++)
    {
        if(Pacijenti[i].first=="A")
        {
            if(Zalihe["A"] + Zalihe["O"]<Pacijenti[i].second)
            {
                cout<<"nemoguce";
                return 0;
            }
            else
            {
                if(Zalihe["A"]>=Pacijenti[i].second)
                {
                    ans[i][1]=Pacijenti[i].second;
                    Zalihe["A"]-=Pacijenti[i].second;
                }
                else
                {
                    ans[i][1]=Zalihe["A"];
                    ans[i][0]=Pacijenti[i].second-Zalihe["A"];
                    Zalihe["O"]-=(Pacijenti[i].second-Zalihe["A"]);
                    Zalihe["A"]=0;
                }
            }
        }
    }

    for(int i = 0; i<n; i++)
    {
        if(Pacijenti[i].first=="B")
        {
            if(Zalihe["B"] + Zalihe["O"]<Pacijenti[i].second)
            {
                cout<<"nemoguce";
                return 0;
            }
            else
            {
                if(Zalihe["B"]>= Pacijenti[i].second)
                {
                    ans[i][2]=Pacijenti[i].second;
                    Zalihe["B"]-=Pacijenti[i].second;
                }
                else
                {
                    ans[i][2]=Zalihe["B"];
                    ans[i][0]=Pacijenti[i].second-Zalihe["B"];
                    Zalihe["O"]-=(Pacijenti[i].second-Zalihe["B"]);
                    Zalihe["B"]=0;
                }
            }
        }
    }
    for(int i = 0; i<n; i++)
    {
        if(Pacijenti[i].first=="AB")
        {
            if(Zalihe["A"] + Zalihe["B"] + Zalihe["O"] + Zalihe["AB"]<Pacijenti[i].second)
            {
                cout<<"nemoguce"<<i;
                return 0;
            }
            if(Pacijenti[i].second!=0 && Zalihe["AB"]!=0)
            {
                if(Pacijenti[i].second<=Zalihe["AB"])
                {
                    ans[i][3]=Pacijenti[i].second;
                    Zalihe["AB"]-=Pacijenti[i].second;
                    Pacijenti[i].second=0;
                }
                else
                {
                    ans[i][3]=Zalihe["AB"];
                    Pacijenti[i].second-=Zalihe["AB"];
                    Zalihe["AB"]=0;
                }
            }
            if(Pacijenti[i].second!=0 && Zalihe["B"]!=0)
            {
                if(Pacijenti[i].second<=Zalihe["B"])
                {
                    ans[i][2]=Pacijenti[i].second;
                    Zalihe["B"]-=Pacijenti[i].second;
                    Pacijenti[i].second=0;
                }
                else
                {
                    ans[i][2]=Zalihe["B"];
                    Pacijenti[i].second-=Zalihe["B"];
                    Zalihe["B"]=0;
                }
            }
            if(Pacijenti[i].second!=0 && Zalihe["A"]!=0)
            {
                if(Pacijenti[i].second<=Zalihe["A"])
                {
                    ans[i][1]=Pacijenti[i].second;
                    Zalihe["A"]-=Pacijenti[i].second;
                    Pacijenti[i].second=0;
                }
                else
                {
                    ans[i][1]=Zalihe["A"];
                    Pacijenti[i].second-=Zalihe["A"];
                    Zalihe["A"]=0;
                }
            }
            if(Pacijenti[i].second!=0 && Zalihe["O"]!=0)
            {
                if(Pacijenti[i].second<=Zalihe["O"])
                {
                    ans[i][0]=Pacijenti[i].second;
                    Zalihe["O"]-=Pacijenti[i].second;
                    Pacijenti[i].second=0;
                }
                else
                {
                    ans[i][0]=Zalihe["O"];
                    Pacijenti[i].second-=Zalihe["O"];
                    Zalihe["O"]=0;
                }
            }
        }
    }

    cout<<"moguce"<<endl;
    for(int i = 0; i<n; i++)
    {
        for(int j =0;j<4;j++)
        {
            cout<<ans[i][j]<<" ";
        }
        cout<<endl;
    }
    return 0;
}